
#include <hmg.ch>
#include <dbstruct.ch> 
#include <hmg_BoxLetterShow.ch>
#include <Repor_00.prg>

*---------------------------------------------------*
Function Main   
*---------------------------------------------------*

   REQUEST DBFCDX , DBFFPT , DBFDBT
   RDDSETDEFAULT( "DBFCDX" )

   REQUEST HB_CODEPAGE_ESWIN     
   HB_SETCODEPAGE("ESWIN")    
 
   REQUEST HB_LANG_ES   
   HB_LANGSELECT("ES")  
*----------------------------------* 
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH  
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET DECIMALS TO 2
  SET TOOLTIPSTYLE BALLOON 
  SET DEFAULT ICON TO "Resource\Beer.ico"

  PUBLIC aGrid := {}

  PUBLIC iX, cList_0X := "" 
  PUBLIC cList_1X , cList_2X , cList_3X , cList_4X    
  PUBLIC cList_5X , cList_6X , cList_7X , cList_8X , cList_9X     

  PRIVATE i,cList := "" , perrix ,  deCimals 
  PRIVATE cListX , cListQ , cListZ , nCount 

  PRIVATE aRC   
  PRIVATE aItem 

  PUBLIC PhotoFile , ficherAaX , Nuevo 
  PUBLIC aFilters  := { {'jpg Files','*.jpg'} }

  PUBLIC lAdjustImage := .T.
   
  PUBLIC InfoDer,  InfoDer1 ,   InfoIzq ,  InfoIzq2 , cValore 

  Declare window Form_50
  Declare window Form_2Q 

  InfoDer  := 0
  InfoIzq  := 0

  InfoDer1 := 0
  InfoIzq2 := 0

  CreateArray_1Q() 

*---------------------------------------------- Color Barra Video Inversa --------------------------------------*
  PRIVATE QfColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }
  PRIVATE Qbcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , {180,200,255} , {255,255,211} ) }   
*---------------------------------------------- Color Barra Video Inversa --------------------------------------*

  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
   

        DEFINE WINDOW Form_50                     ;
		AT 0,0                            ;
		WIDTH  815                        ; 
		HEIGHT 665                        ;  
                BACKCOLOR { 096,110,192}          ;  
		TITLE 'Stock Productos'           ;                   
                MAIN NOMAXIMIZE NOMINIMIZE NOSIZE ;  
                ON INIT ( GoFirstQ() , ArribAbajoTy() )               

                ON KEY ESCAPE ACTION Form_50.Release

     @ 020,612 LABEL Label_3x             ;
	        WIDTH 130 HEIGHT 18       ;
	        VALUE 'Picture:'          ;
                BACKCOLOR { 096,110,192}  ;
                FONTCOLOR { 151,223,255}  ;
	        FONT 'Arial' SIZE 10 BOLD ITALIC
      
     @ 020,667 LABEL Label_4x            ;
	        WIDTH 100 HEIGHT 18       ;
	        VALUE ''                  ;
                BACKCOLOR { 096,110,192}  ;
                FONTCOLOR { 151,223,255} ;
	        FONT 'Arial' SIZE 10 BOLD ITALIC 

    @ 040,560 LABEL Label_0x            ;
	        WIDTH 210 HEIGHT 17       ;
	        VALUE '' ;
                BACKCOLOR { 096,110,192}  ;
                FONTCOLOR { 151,223,255} ;
	        FONT 'Arial' SIZE 09 BOLD ITALIC CENTERALIGN

*------------------------------------------------------------------------------------------------------------------*

      @ 029,048 LABEL Label_2x            ;
	        WIDTH 210 HEIGHT 17       ;
	        VALUE 'Buscar Productos:' ;
                BACKCOLOR { 096,110,192}  ;
                FONTCOLOR { 151,223,255} ;
	        FONT 'Arial' SIZE 10 BOLD ITALIC CENTERALIGN
 

    DEFINE TEXTBOX Text_002X
        ROW    028
        COL    234
        WIDTH  200
        HEIGHT 24
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE SearchChange_3()      
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR { 180,200,255 }    
        FONTCOLOR NIL
        INPUTMASK nil
        FORMAT Nil
        NUMERIC .F.
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------------------------------------------------------*
*---------------------------------------------------  Colors Automatic -------------------------------------------* 
* nCount  :=  ?  // View N Columms ---->    CreateArray_1Q()                                      
  xnCount := nCount -1                                                                
  xbColor := "{ " + REPLICATE(  ALLTRIM("QbColor,") , xnCount ) + ALLTRIM("QbColor") +" }" 
  xfColor := "{ " + REPLICATE(  ALLTRIM("QfColor,") , xnCount ) + ALLTRIM("QfColor") +" }" 
*-----------------------------------------------------------------------------------------------------------------* 
*-----------------------------------------------------------------------------------------------------------------*

    DEFINE GRID Grid_6      // <---------- Productos  Stock
      ROW     067
      COL     030
      WIDTH   500
      HEIGHT  222  
      HEADERS { "Ref","Producto","Tipo","Precio","CBarras","Vector" }
      WIDTHS  { 068 , 155 , 085 , 060 , 110, 0 }  
      JUSTIFY { 1,0,0,1,0,1}      
      ITEMS aGrid
      DYNAMICBACKCOLOR &(xbColor) 
      DYNAMICFORECOLOR &(xfColor) 
      BACKCOLOR { 209,238,238 }
      FONTCOLOR { 000,255,020 } 
      ONCHANGE  ArribAbajoTy() 
      MULTISELECT .F.
      FONTNAME 'Arial'
      FONTSIZE 9
      CELLNAVIGATION .T.
    END GRID

     Form_50.Grid_6.CheckBoxEnabled := .T.

*-----------------------------------------------------------------------------------------------------------------* 

     @ 307,070 BUTTON Bust_04               ;  
               CAPTION SPACE(3)-'N&ew'      ;
               PICTURE 'Resource\New.bmp'   ;
               LEFT                         ; 
               WIDTH  095 HEIGHT 37         ;
               TOOLTIP 'New'                ;
               ACTION Autorize_01()

     @ 307,180 BUTTON Bust_05               ;
               CAPTION SPACE(2)-'E&dit'     ;
               PICTURE 'Resource\Modify.bmp';
               LEFT                         ; 
               WIDTH  095 HEIGHT 37         ;
               TOOLTIP ''                   ;
               ACTION checkboxStock()  

     @ 307,290 BUTTON Bust_06               ;
               CAPTION SPACE(2)-'B&aja'     ;
               PICTURE 'Resource\Eraser.bmp';
               LEFT                         ; 
               WIDTH  095 HEIGHT 37         ;
               TOOLTIP ''                   ;
               ACTION Erase_GetListStock()    

     @ 307,400 BUTTON Bust_07               ;
               CAPTION SPACE(2)-'L&ist'     ;
               PICTURE 'Resource\Print.bmp' ;
               LEFT                         ; 
               WIDTH  095 HEIGHT 37         ;
               TOOLTIP ''                   ;
               ACTION Report_0x()    

    @ 563,637 BUTTON Bust_08                ;  
              CAPTION SPACE(5)-'E&xit'      ;
              PICTURE "Resource\Exit.bmp"   ;
              LEFT                          ;  
              WIDTH  095 HEIGHT 37          ;
              TOOLTIP ''                    ;
              ACTION Form_50.Release 


*---------------------------------------------------------------------*
*---------------------------  Up-Down  -------------------------------*
*---------------------------------------------------------------------*

    DEFINE BUTTON But_01  
         ROW    566 
         COL    485
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/btn_01.bmp"            
         TOOLTIP 'Primero' 
         ACTION ( GoFirstQ() , ArribAbajoTy() )             
     END BUTTON

    DEFINE BUTTON But_02 
         ROW    566  
         COL    515  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/btn_02.bmp"       
         TOOLTIP 'Anterior'  
         ACTION ( GoPreviousQ() , ArribAbajoTy() ) 
    END BUTTON
 
    DEFINE BUTTON But_03
         ROW    566  
         COL    545  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/btn_03.bmp"           
         TOOLTIP 'Siguiente'    
         ACTION (  GoNextQ()  , ArribAbajoTy() )  
    END BUTTON   

    DEFINE BUTTON But_04
          ROW   566 
         COL    575  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/btn_04.bmp"            
         TOOLTIP 'Ultimo' 
         ACTION ( GoLastQ()  , ArribAbajoTy()  ) 
    END BUTTON 
 
*---------------------------------------------------------------------*
*--------------------------- End  Up-Down  ---------------------------*
*---------------------------------------------------------------------*
 
          Box( 366 , 053 , 450 , 178, "17hi", 213, 249, 213 )  
          SetProperty("Form_50","Label_17hi","Enabled", .F. )  
         
  DEFINE LABEL Label_13
        ROW    379
        COL    085 
        WIDTH  080
        HEIGHT 020
        VALUE "Ref:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  { 213,249,213 }  
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX  Control_13
        ROW    378  
        COL    180
        WIDTH  110
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Ref"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR NIL
        INPUTMASK '99999'
        FORMAT Nil
        NUMERIC .T. 
        VALUE 0 
    END TEXTBOX
		
*-----------------------------------------------------------------*

    DEFINE LABEL Label_23
        ROW    406
        COL    085 
        WIDTH  080
        HEIGHT 020
        VALUE "Producto:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  { 213,249,213 }  
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_23
        ROW    405  
        COL    180
        WIDTH  250
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Producto"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 40
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_33
        ROW    431
        COL    085 
        WIDTH  080
        HEIGHT 020
        VALUE "Tipo:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 213,249,213 }  
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_33
        ROW    430  
        COL    180
        WIDTH  140
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Tipo"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 40
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*
		
    DEFINE LABEL Label_43
        ROW    455
        COL    085 
        WIDTH  080
        HEIGHT 020
        VALUE "Precio:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  { 213,249,213 }  
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_43
        ROW    454 
        COL    180
        WIDTH  080
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Precio"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 7
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR NIL
        INPUTMASK "9999.99"
        FORMAT 'E'
        NUMERIC .T.
        VALUE 0.00   
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_53
        ROW    481
        COL    085 
        WIDTH  080
        HEIGHT 020
        VALUE "Vector:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 213,249,213 }   
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX Control_53
        ROW    480 
        COL    180
        WIDTH  080
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Vector"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 4
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR NIL
        INPUTMASK "9999"
        FORMAT Nil
        VALUE "0000"
    END TEXTBOX


     DEFINE LABEL LABEL_63
        ROW    506
        COL    085
        WIDTH  080
        HEIGHT 020
        VALUE "CBarras:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR  { 213,249,213 }  
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX Control_63
        ROW    505  
        COL    180
        WIDTH  140
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 13
        BACKCOLOR { 180,200,255 } 
        FONTCOLOR NIL
        INPUTMASK "9999999999999"
        FORMAT Nil
        NUMERIC .T.
    END TEXTBOX


*---------------------------- Box Photo -------------------------------*

         Box(  366 , 592 , 175 , 175, "18hi", 255, 255, 255 )  
          SetProperty("Form_50","Label_18hi","Enabled", .T. )  
        
       DEFINE IMAGE MostraryX
           ROW 383 ; COL 606; WIDTH 147 ; HEIGHT 146  
           PICTURE 'Productos\9999.jpg'
           STRETCH .T.
       END IMAGE

*---------------------------------------------------------------------*
*---------------------------------------------------------------------*

      @ 563,070 BUTTON Select_NPhoto    ;    
                CAPTION "Photo"        ;
                PICTURE "resource\portrait_add.bmp" LEFT ;
		TOOLTIP "New Photo" ;
		ACTION Select_Photo() ;  
		WIDTH 100 ;
		HEIGHT 40 ;
                FONT "ARIAL" SIZE 9 BOLD

*---------------------------------------------------------------------*

*---------------------------------------------------------------------*
*------------------------------  New ---------------------------------*

       @ 563,260 BUTTON SAVE_23      ;  
         CAPTION "&Save"             ;
         PICTURE "resource\ok.bmp"   ;
         FONT "Arial"                ;
         SIZE 9                      ;
         BOLD                        ;
         ITALIC                      ;
         ACTION ( Altax5Q() , Anulax_01() ) ;   
         TOOLTIP "Save"              ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40 

       @ 563,370 BUTTON CANCEL_23    ;   
         CAPTION "&Cancel"           ;
         PICTURE  "resource\cancelx.bmp" ;
         FONT "Arial"                ;
         SIZE 9                      ; 
         BOLD                        ;
         ITALIC                      ;
         ACTION Anulax_01()          ;             
         TOOLTIP "Cancel"            ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40 

*---------------------------------------------------------------------*
*---------------------------------------------------------------------*


       @ 563,250  BUTTON SAVE_23x    ;
         CAPTION "&Save"             ;
         PICTURE "resource\ok.bmp"   ;
         FONT "Arial"                ;
         SIZE 9                      ;
         BOLD                        ;
         ITALIC                      ;
         ACTION ( Editax6() , Anulax_02() ) ;   
         TOOLTIP "Save"              ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40 

       @ 563,360 BUTTON CANCEL_23x   ;
         CAPTION "&Cancel"           ;
         PICTURE  "resource\cancelx.bmp" ;
         FONT "Arial"                ;
         SIZE 9                      ; 
         BOLD                        ;
         ITALIC                      ;
         ACTION  Anulax_02()         ;       
         TOOLTIP "Cancel"            ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40 


     END WINDOW

         Anulax_01()

         SETWINDOWCURSOR ( Form_50.Bust_08.Handle , "Resource\SmoothHand.cur")
         HMG_ChangeWindowStyle ( GetControlHandle("Grid_6","Form_50"), LVS_REPORT, NIL, .T. )
       	
        CENTER WINDOW Form_50
	ACTIVATE WINDOW Form_50

Retur Nil

*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*


*---------------------------------------------------------*
 FUNCTION CreateArray_1Q() 
*---------------------------------------------------------*

        dbCloseAll()
        SELECT 2
        USE STOCK EXCLUSIVE NEW
        INDEX ON REF TO Stock
        CLOSE DATABASE
        SELECT 2
        USE STOCK INDEX STOCK
	DbGOTOP()
  *     COUNT TO nBra1 FOR STOCK->REF >= 0 
  *     DBEVAL( {|| AADD( arows32,{ STOCK->REF,STOCK->PRODUCTO,STOCK->TIPO,TRAN(STOCK->PRECIO, "@E 999,999.99"),STOCK->CBARRAS ,STOCK->VECTOR } )})    
        
        nCount  := STOCK->( FCOUNT() )   // <----  Saber Nmero Columnas del Grid para el Color  Automtico

	aGrid := {}
	DO WHILE !  STOCK->( Eof()) 
		AADD( aGrid , { STOCK->REF,STOCK->PRODUCTO,STOCK->TIPO,TRAN(STOCK->PRECIO,"@E 999,999.99"),STOCK->CBARRAS ,STOCK->VECTOR } )
		STOCK->(DbSkip())
	ENDDO

Return Nil

*---------------------------------------------------------*
 Procedure SearchChange_3()
*---------------------------------------------------------*
Local  cTxt, nLen, i
cTxt := GetProperty( 'Form_50','Text_002X','Value' )
nLen := Len( cTxt )

 // Nesse ponto preciso saber qual o nmero da coluna da Grid

 nCol:= Form_50.Grid_6.Col

  Form_50.Grid_6.DeleteAllItems

 // Procura o texto 

 For i := 1 To Len( aGrid )
     If Upper( cTxt ) = Upper( Left( aGrid [ i ] [ 2] , nLen ) )   // [ 2] <------- PRODUCTO
        Form_50.Grid_6.AddItem ( aGrid [ i ] )
     Endif
 Next

Return

*---------------------------------------------------------*
 FUNCTION Anulax_01()
*---------------------------------------------------------*

  Limpia()

  Form_50.Label_13.Enabled   := .F. 
  Form_50.Label_23.Enabled   := .F.  
  Form_50.Label_33.Enabled   := .F. 
  Form_50.Label_43.Enabled   := .F.  
  Form_50.Label_53.Enabled   := .F. 
  Form_50.Label_63.Enabled   := .F. 

  Form_50.Control_13.Enabled := .F. 
  Form_50.Control_23.Enabled := .F. 
  Form_50.Control_33.Enabled := .F. 
  Form_50.Control_43.Enabled := .F. 
  Form_50.Control_53.Enabled := .F. 
  Form_50.Control_63.Enabled := .F. 

  Form_50.Select_NPhoto.Enabled := .F. 

  Form_50.SAVE_23.Show   
  Form_50.CANCEL_23.Show  
  
  Form_50.SAVE_23.Enabled := .F.   
  Form_50.CANCEL_23.Enabled := .F.   

  Form_50.SAVE_23x.Hide 
  Form_50.CANCEL_23x.Hide  


 Form_50.Grid_6.CheckBoxEnabled := .F.
 Form_50.Grid_6.CheckBoxEnabled := .T.

Return Nil

*---------------------------------------------------------*
FUNCTION Anulax_02()
*---------------------------------------------------------*

  Limpia()

  Form_50.Label_13.Enabled   := .F. 
  Form_50.Label_23.Enabled   := .F.  
  Form_50.Label_33.Enabled   := .F. 
  Form_50.Label_43.Enabled   := .F.  
  Form_50.Label_53.Enabled   := .F. 
  Form_50.Label_63.Enabled   := .F. 

  Form_50.Control_13.Enabled := .F. 
  Form_50.Control_23.Enabled := .F. 
  Form_50.Control_33.Enabled := .F. 
  Form_50.Control_43.Enabled := .F. 
  Form_50.Control_53.Enabled := .F. 
  Form_50.Control_63.Enabled := .F. 

  Form_50.Select_NPhoto.Enabled := .F. 

  Form_50.SAVE_23.Show   
  Form_50.CANCEL_23.Show  
 
  Form_50.SAVE_23.Enabled := .F.   
  Form_50.CANCEL_23.Enabled := .F.   


  Form_50.SAVE_23x.Hide 
  Form_50.CANCEL_23x.Hide  


  Form_50.Grid_6.CheckBoxEnabled := .F.
  Form_50.Grid_6.CheckBoxEnabled := .T.


Return Nil


*---------------------------------------------------------*
FUNCTION Limpia()
*---------------------------------------------------------*

 Form_50.Control_13.Value  :=  0 
 Form_50.Control_23.Value  := ""
 Form_50.Control_33.Value  := ""
 Form_50.Control_43.Value  := 0.00
 Form_50.Control_53.Value  := "Productos\9999.jpg"
 Form_50.Control_63.Value  := 0
 Form_50.MostraryX.Picture := "Productos\9999.jpg"

Return Nil


*---------------------------------------------------------*
FUNCTION Autorize_01()
*---------------------------------------------------------*

  Form_50.Label_13.Enabled   := .T. 
  Form_50.Label_23.Enabled   := .T.  
  Form_50.Label_33.Enabled   := .T. 
  Form_50.Label_43.Enabled   := .T.  
  Form_50.Label_53.Enabled   := .T. 
  Form_50.Label_63.Enabled   := .T. 

  Form_50.Control_13.Enabled := .T. 
  Form_50.Control_23.Enabled := .T. 
  Form_50.Control_33.Enabled := .T. 
  Form_50.Control_43.Enabled := .T. 
  Form_50.Control_53.Enabled := .T. 
  Form_50.Control_63.Enabled := .T. 

  Form_50.Select_NPhoto.Enabled := .T.  

  Form_50.SAVE_23.Show  
  Form_50.CANCEL_23.Show   

  Form_50.SAVE_23.Enabled := .T.   
  Form_50.CANCEL_23.Enabled := .T.   

  Form_50.SAVE_23x.Hide 
  Form_50.CANCEL_23x.Hide  

Return Nil

*---------------------------------------------------------*
FUNCTION Autorize_02()
*---------------------------------------------------------*

  Form_50.Label_13.Enabled   := .T. 
  Form_50.Label_23.Enabled   := .T.  
  Form_50.Label_33.Enabled   := .T. 
  Form_50.Label_43.Enabled   := .T.  
  Form_50.Label_53.Enabled   := .T. 
  Form_50.Label_63.Enabled   := .T. 

  Form_50.Control_13.Enabled := .T. 
  Form_50.Control_23.Enabled := .T. 
  Form_50.Control_33.Enabled := .T. 
  Form_50.Control_43.Enabled := .T. 
  Form_50.Control_53.Enabled := .T. 
  Form_50.Control_63.Enabled := .T. 

  Form_50.Select_NPhoto.Enabled := .T.  

  Form_50.SAVE_23.Hide   
  Form_50.CANCEL_23.Hide   

  Form_50.SAVE_23x.Show
  Form_50.CANCEL_23x.Show

 Return Nil

*---------------------------------------------------------*
 Function GoFirstQ()
*---------------------------------------------------------*

 Form_50.Grid_6.SetFocus
 Form_50.Grid_6.Value := { 1, Form_50.Grid_6.Value[2] }

 Return

*---------------------------------------------------------*
 Function GoPreviousQ()
*---------------------------------------------------------*
  LOCAL aValue := Form_50.Grid_6.Value

  Form_50.Grid_6.SetFocus

  IF aValue[1] > 1
    Form_50.Grid_6.Value := { aValue[1] - 1, aValue[2] }
  ENDIF

 Return

*---------------------------------------------------------*
 Function GoNextQ()
*---------------------------------------------------------*
  LOCAL aValue := Form_50.Grid_6.Value

  Form_50.Grid_6.SetFocus

  IF aValue[1] < Form_50.Grid_6.Itemcount
    Form_50.Grid_6.Value := { aValue[1] + 1, aValue[2] } 
  ENDIF

 Return

*---------------------------------------------------------*
 Function GoLastQ()
*---------------------------------------------------------*

 Form_50.Grid_6.SetFocus
 Form_50.Grid_6.Value := { Form_50.Grid_6.Itemcount, Form_50.Grid_6.Value[2] }

 Return

*----------------------------------------------------------*
FUNCTION ArribAbajoTy()     // Cuenta Registros   Bueno
*----------------------------------------------------------*

*---> Nombre de Picture Database 

  cnRowQ := Form_50.Grid_6.Value[ 1 ] 
  miruxQ  := SUBSTR(  Form_50.Grid_6.cell( cnRowQ,6 ) ,11,9 )  
  Form_50.Label_4x.Value :=  miruxQ

  cValore :=  Form_50.Grid_6.cell( cnRowQ,6 )

  Infox_Imag()   


Return 	


*-----------------------------------------------------------------------------------------------------------------------*
******************************************************  Altas Stock *****************************************************
*-----------------------------------------------------------------------------------------------------------------------*

*------------------------------------------------------------*
 FUNCTION Altax5Q()
*------------------------------------------------------------*
 LOCAL aKeys , cuentame1, cuentame2

 Declare Window Form_50  

   IF UPPER( Form_50.Control_33.Value ) <= SPACE(1)
       MsgStop('Write Full Name!','warning!')
       return
   ENDIF

   SELECT 2
   USE STOCK INDEX STOCK
   DbGoBottom() 

   IF UPPER( Form_50.Control_23.Value ) <= SPACE(1)
       msgStop('Write Full Name!','warning!')
       return
  ENDIF

*-------------------------------------------------------------------------------------------------*
    APPEND BLANK
    REPLACE STOCK->REF        WITH       Form_50.Control_13.Value      //  new_Ref 
    REPLACE STOCK->PRODUCTO   WITH UPPER(Form_50.Control_23.Value) 
    REPLACE STOCK->TIPO       WITH UPPER(Form_50.Control_33.Value) 
    REPLACE STOCK->PRECIO     WITH       Form_50.Control_43.Value
*-------------------------------------------------------------------------------------------------*

    IF  ALLTRIM(Form_50.Control_53.Value) == "0000" .OR. Form_50.Control_53.value == ""
        Form_50.Control_53.Value := "9999"
        REPLACE STOCK->VECTOR  WITH "Productos\9999.jpg"   
    ELSE
        RESTORE FROM Photo_Num.mem ADDITIVE
        Nuevo :=  Form_50.Control_53.Value
        SAVE TO Photo_Num ALL LIKE Nuevo
        REPLACE STOCK->VECTOR  WITH "Productos\"+ ALLTRIM(Form_50.Control_53.Value) +".jpg" 
        Nuevo := "0000" 
        SAVE TO Photo_Num ALL LIKE Nuevo
    ENDIF
 
   cuentame1 := STR( Form_50.Control_63.Value )
   cuentame2 :=  ALLTRIM( cuentame1 )

*-------------------------------------------------------------------------------------------------*

     IF LEN(cuentame2 ) <>  13   
  
       MsgStop("Codigo Barras no es Correcto"+CRLF+CRLF+; 
               "Tiene que ser 13 Nmeros"," Atencin" )
          Return(.F.)
    ELSE
        REPLACE STOCK->CBARRAS    WITH  Form_50.Control_63.Value      
    ENDIF 

  Declare window  Form_50

*-------------------------------------------------------------------------------------------------* 

   Form_50.Grid_6.AddItem( {  Form_50.Control_13.Value ,   UPPER(Form_50.Control_23.Value) , UPPER(Form_50.Control_33.Value) ,; 
                              Form_50.Control_43.Value ,   Form_50.Control_63.Value , ALLTRIM(Form_50.Control_53.Value)  } )     

   Form_50.Grid_6.Value := Form_50.Grid_6.ItemCount

   SET EXCLUSIVE OFF
   CLOSE DATABASE
   UNLOCK ALL
   SET EXCLUSIVE ON

   SELECT 2
   USE STOCK INDEX STOCK
   Reindex 
   CreateArray_1Q() 

*--------------------------------------------------------------------------------------------------*
        fReg := Form_50.Grid_6.ItemCount 
        Form_50.Grid_6.DeleteAllItems                     // BORRA TODOS LOS ITEMS EN LA GRID.
	nReg := Len( aGrid )                              // CUANTOS REGISTROS EXISTEN EN MI ARRAY
	FOR n:= 1 TO  fReg   
		Form_50.Grid_6.AddItem( aGrid [n])         // AGREGO CADA REGISTRO EN LA GRID
	NEXT n
*--------------------------------------------------------------------------------------------------*
      
  CreateArray_1Q() 
  GoFirstQ()

  Form_50.Grid_6.Refresh
  Form_50.Grid_6.SetFocus

Return



*-----------------------------------------------------------------------------------------------------------------------*
*******************************************************  Modificar Stock ************************************************
*-----------------------------------------------------------------------------------------------------------------------*

*---------------------------------------------------------*
 FUNCTION checkboxStock()    // para Modificar  Registros
*---------------------------------------------------------*

  FOR i = 1 TO Form_50.Grid_6.ItemCount
      IF Form_50.Grid_6.CheckBoxItem ( i ) == .T.
         HayqueVerStock()                         
      ENDIF 
  NEXT
  
Return Nil


*---------------------------------------------------------*
FUNCTION HayqueVerStock()
*---------------------------------------------------------*

 Declare window Form_50

      Autorize_02()   // Abre Bottones

    FOR iX = 1 TO Form_50.Grid_6.ItemCount
         
       IF Form_50.Grid_6.CheckBoxItem ( iX ) == .T.

            cList_0X :=            Form_50.Grid_6.CellEx (iX, 1) +","+ Form_50.Grid_6.CellEx (iX, 2) + "," + Form_50.Grid_6.CellEx (iX, 3) +"," ;
                                 + Form_50.Grid_6.CellEx (iX, 4) +","+ Form_50.Grid_6.CellEx (iX, 5) + "," + Form_50.Grid_6.CellEx (iX, 6) +"," ;
                                 + HB_OsNewLine()

            cList_1X :=  Form_50.Grid_6.CellEx (iX, 1) 
            cList_2X :=  Form_50.Grid_6.CellEx (iX, 2) 
            cList_3X :=  Form_50.Grid_6.CellEx (iX, 3) 
            cList_4X :=  Form_50.Grid_6.CellEx (iX, 4) 
            cList_5X :=  Form_50.Grid_6.CellEx (iX, 5) 
            cList_6X :=  Form_50.Grid_6.CellEx (iX, 6) 
          
       ENDIF
    NEXT

     deCimals :=  STRTRAN ( cList_4X, ",", ".")


     Form_50.Control_13.Value  :=      VAL(cList_1X)         //"Ref:"
     Form_50.Control_23.Value  :=          cList_2X          //"Producto:" 
     Form_50.Control_33.Value  :=          cList_3X          //"Tipo"
     Form_50.Control_43.Value  :=      VAL(deCimals)         //"Precio"
     Form_50.Control_53.Value  :=  SUBSTR( cList_6X,10,5 )   //"Vector:"
     Form_50.Control_63.Value  :=      VAL(cList_5X)         //"CBarras:"
     Form_50.MostraryX.Picture :=          cList_6X          // cList_6X  
     
Return Nil


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*------------------------------------------------------------*
 Function Editax6()
*------------------------------------------------------------*

* Declare Window Form_54   

 LOCAL xqQ := Form_50.Control_13.Value
 LOCAL cuentame1x ,  cuentame2x

 dbcloseaLL()
 SELECT 2
 SET EXCLUSIVE ON
 USE STOCK
 UNLOCK ALL
 SET EXCLUSIVE OFF

 LOCATE FOR STOCK->REF = xqQ 

  IF FOUND()
  * REPLACE STOCK->REF        WITH       Form_50.Control_13.Value   // No se permite Cambiar Ref
    REPLACE STOCK->PRODUCTO   WITH UPPER(Form_50.Control_23.Value) 
    REPLACE STOCK->TIPO       WITH UPPER(Form_50.Control_33.Value) 
    REPLACE STOCK->PRECIO     WITH       Form_50.Control_43.Value
   IF ALLTRIM( Form_50.Control_53.Value)  == "0000" .OR. ALLTRIM(Form_50.Control_53.Value) <= " "
        REPLACE STOCK->VECTOR  WITH "Productos\1000.jpg"   
   ELSE
        REPLACE STOCK->VECTOR  WITH "Productos\"+ ALLTRIM(Form_50.Control_53.Value) +".jpg"      
   ENDIF

    cuentame1x := STR(Form_50.Control_63.Value)
    cuentame2x :=  ALLTRIM( cuentame1x )

*-------------------------------------------------------------------------------------------------*
     IF LEN(cuentame2x ) <>  13   
  
       MsgStop("Codigo Barras no es Correcto" + CRLF + CRLF + ; 
               "Tiene que ser 13 Nmeros"," Atencin" )
          Return(.F.)
     ELSE
        REPLACE STOCK->CBARRAS    WITH    Form_50.Control_63.Value   
     ENDIF 

  ENDIF

   SET EXCLUSIVE OFF
   CLOSE DATABASE
   UNLOCK ALL
   SET EXCLUSIVE ON

   SELECT 2
   USE STOCK INDEX STOCK
   Reindex 
   CreateArray_1Q() 

*--------------------------------------------------------------------------------------------------*
        fReg := Form_50.Grid_6.ItemCount 
        Form_50.Grid_6.DeleteAllItems                     // BORRA TODOS LOS ITEMS EN LA GRID.
	nReg := Len( aGrid )                              // CUANTOS REGISTROS EXISTEN EN MI ARRAY
	FOR n:= 1 TO  fReg   
		Form_50.Grid_6.AddItem( aGrid [n])         // AGREGO CADA REGISTRO EN LA GRID
	NEXT n
*-------------------------------------------------------------------------------------------------*
      
  CreateArray_1Q() 
  GoFirstQ()

  Form_50.Grid_6.Refresh
  Form_50.Grid_6.SetFocus


Return Nil 

*-----------------------------------------------------------------------------------------------------------------------*
*****************************************************  Selection de Photo *************************************************
*-----------------------------------------------------------------------------------------------------------------------*

*------------------------------------------------------------*
 FUNCTION Select_Photo()
*------------------------------------------------------------*

   PhotoFile := Getfile ( aFilters , 'Select Photo' , 'Productos\' , .F. , .T. )
*------------------------------------------------------------*

 IF .NOT. FILE ( PhotoFile )
      MsgInfo("No se ha elejido Photo "," ATENCION !!!")
     RETURN
 ENDIF
*------------------------------------------------------------*
   Nuevo := "0000" 
   SAVE TO Photo_Num ALL LIKE Nuevo
*---------------------------------------------------------------------------------------------------*
   ficherAaX := RIGHT( PhotoFile , LEN(PhotoFile) - RAT("\", PhotoFile ))
*------------------------------ Calcula Longitud Fichero jpg ---------------------------------------*
   Nuevo =  LEFT (ficherAaX, LEN( ficherAaX ) - 4 )

   SAVE TO Photo_Num ALL LIKE Nuevo
 
*------------------------------------ View Changes Photo  ------------------------------------------*

      RESTORE FROM Photo_Num.mem ADDITIVE
      Form_50.Mostraryx.Picture := "Productos\"+ALLTRIM(Nuevo)+".jpg"   
      Form_50.Control_53.value := ALLTRIM(NUEVO)

      IF NUEVO == ""
         Form_50.Control_53.value := "0000"
      ENDIF

  Return Nil


*-----------------------------------------------------------------------------------------------------------------------*
*************************************************************  Borrar  Registros ****************************************
*-----------------------------------------------------------------------------------------------------------------------*

*-------------------------------------------------*
 FUNCTION Erase_GetListStock()
*-------------------------------------------------*

 aRC   :=  Form_50.Grid_6.Value
 aItem :=  Form_50.Grid_6.Item(aRC[1])

 SET EXCLUSIVE OFF 
 UNLOCK ALL
 SET EXCLUSIVE ON

    FOR i = 1 TO  Form_50.Grid_6.ItemCount
          IF Form_50.Grid_6.CheckBoxItem ( i ) == .T.
             cList := cList +  Form_50.Grid_6.CellEx (i, 1) +", "+  Form_50.Grid_6.CellEx (i, 2) + HB_OsNewLine()

             cListX :=   Form_50.Grid_6.CellEx (i, 1) 
             cListQ :=   Form_50.Grid_6.CellEx (i, 2) 
             cListZ :=   Form_50.Grid_6.CellEx (i, 3) 

             dbCloseAll()
             USE STOCK 
             LOCATE FOR  STOCK->REF =  VAL(cListX)   
          IF FOUND()
              perrix := STOCK->REF     //R_SOCIAL 

          IF MsgYesNo( "Proceed to Remove the Record ?" + CRLF + CRLF+; 
               "Ref:      "+ SPACE(5) +  LTRIM(cListX)  + CRLF + ;          
                "Producto: "+ ALLTRIM(cListQ )  ,"Delete Records" )  

              Form_50.Grid_6.DeleteItem(aRC[1])
              DELETE 
              PACK
              Form_50.Grid_6.Refresh
              Form_50.Grid_6.SetFocus
           ENDIF
          ENDIF   
       ENDIF
      NEXT

*----------------------------------------------------*

   SET EXCLUSIVE OFF
   CLOSE DATABASE
   UNLOCK ALL
   SET EXCLUSIVE ON

   SELECT 2
   USE STOCK INDEX STOCK
   Reindex 
   CreateArray_1Q() 

        fReg := Form_50.Grid_6.ItemCount 
        Form_50.Grid_6.DeleteAllItems                     // BORRA TODOS LOS ITEMS EN LA GRID.
	nReg := Len( aGrid )                              // CUANTOS REGISTROS EXISTEN EN MI ARRAY
	FOR n:= 1 TO  fReg   
		Form_50.Grid_6.AddItem( aGrid [n])         // AGREGO CADA REGISTRO EN LA GRID
	NEXT n
      
  CreateArray_1Q() 
  GoFirstQ()

  Anulax_01()

  Form_50.Grid_6.Refresh
  Form_50.Grid_6.SetFocus


RETURN

*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*-_*-*_-*



*----------------------------------------------------------------------------*
PROCEDURE Infox_Imag()   
*----------------------------------------------------------------------------*

    cMessage := ImageInfo( cValore )

   IF HB_ISNIL( cMessage ) 
      MsgStop( "Couldn't get image info !", "Error !" )
   ELSE
      InfoDer :=  SUBSTR(  cMessage , 1 , 4)  
      infoIzq :=  SUBSTR(  cMessage , 5)   
  
      InfoDer1 :=  VAL(ALLTRIM(InfoDer)) 
      infoIzq2 :=  VAL(ALLTRIM(InfoIzq)) 

  Form_50.Label_0x.Value := "Pixeles: "+ SPACE(1) + ALLTRIM( InfoDer) + SPACE(1) + "x" + SPACE(1) + ALLTRIM( InfoIzq )

   IF ISWINDOWACTIVE( "Form_2Q" ) 
      Form_2Q.Release 
   ENDIF

      PiPeaRe()

   ENDIF
 
RETURN 
 
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*----------------------------------------------------------------------------*
FUNCTION ImageInfo( cIMageFName )
*----------------------------------------------------------------------------*    
    LOCAL xRVal, nWidth, nHeight

   IF FILE( cIMageFName ) 
      IF HMG_GetImageInfo ( cIMageFName, @nWidth, @nHeight)
         xRVal :=  NTOC( nWidth )  +  SPACE(2) + NTOC( nHeight )   
      ENDIF
   ENDIF

RETURN xRVal // ImageInfoVerbose()


*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*----------------------------------------------------------------------------*
FUNCTION  PiPeaRe()
*----------------------------------------------------------------------------*

  IF InfoIzq2  >= 4160
     InfoDer1  = InfoDer1 /5   
     InfoIzq2  = InfoIzq2 /5      
  ENDIF

  IF InfoIzq2  >= 1770 
     InfoDer1  = InfoDer1 /4  
     InfoIzq2  = InfoIzq2 /4   
  ENDIF

  IF InfoIzq2  >= 1600
     InfoDer1  = InfoDer1 /3 
     InfoIzq2  = InfoIzq2 /3 
  ENDIF

  IF InfoIzq2  >= 724 
     InfoDer1  = InfoDer1 /5 
     InfoIzq2  = InfoIzq2 /5 
  ENDIF

  IF InfoIzq2  >= 594 
     InfoDer1  = InfoDer1 /3 
     InfoIzq2  = InfoIzq2 /3 
  ENDIF

  IF InfoIzq2  >= 447 
     InfoDer1  = InfoDer1 /2 
     InfoIzq2  = InfoIzq2 /2  
  ENDIF

/*
  IF InfoIzq2  >= 281 
     InfoDer1  = InfoDer1 /2 
     InfoIzq2  = InfoIzq2 /2
  ENDIF
*/

  IF InfoIzq2  >= 281 
     InfoDer1  = 186
     InfoIzq2  = 255
  ENDIF


 Declare window Form_50

   IF ISWINDOWACTIVE( Form_2Q ) 
      DoMethod ( ' Form_2Q ' , 'Release' )
   ENDIF

 DEFINE WINDOW Form_2Q       ;
      AT 148 , 820              ;
      WIDTH   InfoDer1 + 19 ;
      HEIGHT  InfoIzq2 + 21 ; 
      NOMAXIMIZE NOMINIMIZE NOSYSMENU ;
      NOCAPTION NOSIZE  ;
      CHILD 

 Box(  01 ,01, InfoDer1 + 16 ,InfoIzq2 + 19, "16rhi", 255, 255, 255 )  
                 SetProperty("Form_2Q","Label_16rhi","Enabled", .T. )  

      ON KEY ESCAPE ACTION Form_50.Release   //<== Exit Total

    DEFINE IMAGE Mostrary
           ROW 10  
           COL 10 
           WIDTH  InfoDer1 
           HEIGHT InfoIzq2 
           PICTURE ''
           STRETCH .T.
           ADJUSTIMAGE lAdjustImage
     END IMAGE

   END WINDOW


   Form_2Q.Mostrary.Picture :=  cValore             

   ACTIVATE WINDOW Form_2Q

Return Nil


*-._.-*-._.-*-._.-*-._.-*-._.-*-._.*-._.-*-._.-*-._.-*-._.-*-._.-*-._.-*-._.-*-._.-*-._.*-._.-*-._.-*-._.-*-._.-*-._.-*              










